## botch 0.21

=== Makefile ===
VERSION=0.21

BIN_OPT:= \
  create-graph.native \
  print-stats.native \
  bin2src.native \
  src2bin.native \
  build-fixpoint.native \
  clean-repository.native \
  buildgraph2srcgraph.native \
  annotate-strong.native \
  partial-order.native \
  find-fvs.native \
  collapse-srcgraph.native \
  optuniv.native \
  calculate-fas.native \
  buildcheck-more-problems.native \
  distcheck-more-problems.native

BIN_BYTE:=$(patsubst %.native, %.byte, $(BIN_OPT))
BIN_DEBUG:=$(patsubst %.native, %.d.byte, $(BIN_OPT))
BIN_PROF:=$(patsubst %.native, %.p.native, $(BIN_OPT))

BIN_PYTOOLS:=$(patsubst tools/%.py, %, $(filter-out tools/util.py tools/debarch.py,$(wildcard tools/*.py)))
BIN_OCTOOLS:=$(patsubst %.native, %, $(BIN_OPT))
BIN_SHTOOLS:=$(patsubst tools/%.sh, %, $(wildcard tools/*.sh))

BIN_TOOLS:=$(BIN_PYTOOLS) $(BIN_OCTOOLS) $(BIN_SHTOOLS)
MANPAGES:=$(patsubst %, doc/man/botch-%.1, $(BIN_TOOLS))

OCAMLBUILD_BEST ?= $(if $(wildcard /usr/bin/ocamlopt),native,byte)

PWD := $(shell pwd)
BUILD = $(PWD)/dose/_build
DOSELIBS = $(PWD)/dose/_build/dose3
CUDFLIBS = $(PWD)/dose/_build/cudf
DOSEBYTELIBS = \
  _build/doselibs/common.cma \
  _build/doselibs/debian.cma \
  _build/doselibs/versioning.cma \
  _build/doselibs/csw.cma \
  _build/doselibs/pef.cma \
  _build/doselibs/algo.cma \
  _build/doselibs/doseparse.cma \
  _build/doselibs/doseparseNoRpm.cma
# we turn on all warnings but turn off:
#   4  Fragile pattern matching: matching that will remain complete even if additional constructors are added to one of the variant types matched.
#   9  Missing fields in a record pattern.
#   24 Bad module name: the source file name is not a valid OCaml module name.
CFLAGS=-cflags "-w +a-4-9-24"
bindir=/usr/bin
datadir=/usr/share/botch
mandir=/usr/share/man

# we have to export PYTHONHASHSEED because otherwise networkx will create
# content with random output order
#   https://bugs.debian.org/cgi-bin/bugreport.cgi?bug=749710
#   https://github.com/networkx/networkx/issues/1181
# on the other hand, the generated hashes are not the same on 32 vs 64 arches
#   http://bugs.python.org/issue22621
#   http://bugs.debian.org/778373
export PYTHONHASHSEED=0
# to make the sort order in the tests locale independent
export LC_COLLATE=C.UTF-8
export LC_ALL=C.UTF-8
# because dose2html outputs utf8 on standard output
export PYTHONIOENCODING=utf-8

.PHONY: all
all: $(OCAMLBUILD_BEST) wiki man

.PHONY: native
native: atdgen
	OCAMLPATH=$(BUILD) ocamlbuild -lflags -runtime-variant,_pic -classic-display -use-ocamlfind $(CFLAGS) $(BIN_OPT)

.PHONY: byte
byte: atdgen
	OCAMLPATH=$(BUILD) ocamlbuild -classic-display -use-ocamlfind $(CFLAGS) $(BIN_BYTE)

.PHONY: debug
debug: atdgen
	OCAMLPATH=$(BUILD) ocamlbuild -classic-display -use-ocamlfind $(CFLAGS) $(BIN_DEBUG)

# profiling for use of native executables with gprof
.PHONY: profile
profile: atdgen
	OCAMLPATH=$(BUILD) ocamlbuild -classic-display -use-ocamlfind $(CFLAGS) $(BIN_PROF)

doc/man/botch.1: $(MANPAGES)
	./doc/man/generate-botch-manpage.py | pod2man --section 1 --center="botch tools" --name botch > $@

.PHONY: man
man: $(MANPAGES) doc/man/botch.1

.PHONY: wiki
wiki:
	$(MAKE) -C doc/wiki

doc/man/%.1: doc/man/%.pod
	pod2man --section 1 --center="botch tools" $< > $@

.PHONY: doselib
doselib:
	(cd dose && ./configure --with-zip --with-bz2 && make clean libs $(DOSEBYTELIBS))
	rm -Rf $(DOSELIBS)
	mkdir -p $(DOSELIBS)
	cp dose/META $(DOSELIBS)
	for i in \
		dose/_build/*/common.* \
		dose/_build/*/versioning.* \
		dose/_build/*/debian.* \
		dose/_build/*/algo.* \
		dose/_build/*/csw.* \
		dose/_build/*/pef.* \
		dose/_build/*/doseparseNoRpm.* \
		dose/_build/*/doseparse.*; do \
	  if [ -e $$i ]; then \
	  cp $$i $(DOSELIBS) ; \
	  rm -f $(DOSELIBS)/*.mlpack $(DOSELIBS)/*.cmx ; \
	  fi ; \
	done
	rm -Rf $(CUDFLIBS)
	mkdir -p $(CUDFLIBS)
	cp dose/cudf/META $(CUDFLIBS)
	cp dose/_build/doselibs/cudf*.cmi $(CUDFLIBS)
	for i in dose/_build/doselibs/cudf.*; do \
	  if [ -e $$i ]; then \
	    cp $$i $(CUDFLIBS) ; \
	    rm -f $(CUDFLIBS)/*.mlpack $(CUDFLIBS)/*.cmx ; \
	  fi ; \
	done

%_j.ml: %.atd
	atdgen -j -j-std $<

%_t.ml: %.atd
	atdgen -t $<

.PHONY: atdgen
atdgen: datatypes_j.ml datatypes_t.ml

# the "while : ; do" loop around graph-difference is a temporary fix to work
# around random segmentation faults. See http://bugs.python.org/issue24605
define diff_tmp_out
	for t in tmp out; do \
		for f in tests/$(1)/$$t/* $$t/*; do basename "$$f"; done | sort | uniq | while read f; do \
			echo checking $$f; \
			case "$$f" in \
				*.xml) \
					echo "+ ./tools/graph-difference.py \"tests/$(1)/$$t/$$f\" \"$$t/$$f\""; \
					while : ; do ./tools/graph-difference.py "tests/$(1)/$$t/$$f" "$$t/$$f"; exit=$$?; if [ $$exit -eq 139 ]; then echo segfault; continue; fi; if [ $$exit -ne 0 ]; then exit 1; else break; fi; done;; \
				*) \
					echo "+ diff -u \"tests/$(1)/$$t/$$f\" \"$$t/$$f\""; \
					cmp --silent "tests/$(1)/$$t/$$f" "$$t/$$f" || { diff -u "tests/$(1)/$$t/$$f" "$$t/$$f" | head --lines 100 && exit 1; };; \
			esac; \
		done; \
	done
endef

.PHONY: test-misc
test-misc: $(OCAMLBUILD_BEST)
	rm -rf tmp out
	mkdir -p tmp out
	$(eval packages := tests/sid-amd64-packages-20160830T000000Z)
	$(eval sources := tests/sid-sources-20160830T000000Z)
	grep-dctrl --exact-match --field Package build-essential $(packages) \
		| ./tools/latest-version.py - - > tmp/build-essential
	./bin2src.$(OCAMLBUILD_BEST) --deb-native-arch=amd64 tmp/build-essential $(sources) \
		> tmp/build-essential-src
	./create-graph.$(OCAMLBUILD_BEST) --deb-native-arch=amd64 --bg $(sources) $(packages) tmp/build-essential-src \
		> tmp/selfcontained_repo.xml
	./tools/buildgraph2packages.py tmp/selfcontained_repo.xml $(packages) \
		> tmp/packages
	./bin2src.$(OCAMLBUILD_BEST) --deb-native-arch=amd64 tmp/packages $(sources) \
		> tmp/sources
	# test botch-calcportsmetric
	./create-graph.$(OCAMLBUILD_BEST) --deb-drop-b-d-indep --deb-native-arch=amd64 tmp/packages tmp/sources --strongtype > tmp/strongbuildgraph.xml
	./buildgraph2srcgraph.$(OCAMLBUILD_BEST) tmp/strongbuildgraph.xml --deb-drop-b-d-indep --deb-native-arch=amd64 tmp/packages tmp/sources > tmp/strongsrcgraph.xml
	./create-graph.$(OCAMLBUILD_BEST) --deb-drop-b-d-indep --deb-native-arch=amd64 tmp/packages tmp/sources --closuretype > tmp/closurebuildgraph.xml
	./buildgraph2srcgraph.$(OCAMLBUILD_BEST) tmp/closurebuildgraph.xml --deb-drop-b-d-indep --deb-native-arch=amd64 tmp/packages tmp/sources > tmp/closuresrcgraph.xml
	./tools/calcportsmetric.py tmp/strongsrcgraph.xml tmp/closuresrcgraph.xml > out/importance_metric.txt
	# test botch-multiarch-interpreter-problem
	dose-ceve --deb-drop-b-d-indep --deb-native-arch=amd64 -G pkg -T grml deb://tmp/packages debsrc://tmp/sources > tmp/ma_interpreter.pkggraph
	./tools/multiarch-interpreter-problem.py --packages tmp/packages tmp/ma_interpreter.pkggraph > out/ma_interpreter.txt
	# test y-u-b-d-transitive-essential
	./tools/y-u-b-d-transitive-essential.sh --debug --verbose --develop --tmp tmp --output out amd64 tmp/packages tmp/sources acl
	# test botch-buildcheck-more-problems
	./buildcheck-more-problems.$(OCAMLBUILD_BEST) --verbose --progress --checkonly=plasma-desktop,haskell-hledger-ui --deb-native-arch=amd64 --explain --failures $(packages) $(sources) > out/buildcheck.yaml || [ $$? -eq 1 ]
	# test botch-buildcheck-more-problems cross because we want to be able
	# to check yaml output that contains a depchain with an implicit
	# dependency on a package that is Essential:yes (and thus there is no
	# "depends" field)
	./tools/convert-arch.py amd64 armhf tmp/packages - | grep-dctrl -X \( --not -FArchitecture all --and --not -FMulti-Arch foreign \) > tmp/packages_armhf_noall_nomaforeign
	./buildcheck-more-problems.$(OCAMLBUILD_BEST) --verbose --progress --checkonly=apache2,ant --deb-native-arch=amd64 --deb-host-arch=armhf --explain --failures tmp/packages_armhf_noall_nomaforeign tests/crossbuild-essential-armhf tmp/packages tmp/sources > out/buildcheck_cross.yaml || [ $$? -eq 1 ]
	# test botch-distcheck-more-problems
	./distcheck-more-problems.$(OCAMLBUILD_BEST) --verbose --progress --checkonly=task-kde-desktop:amd64,libghc-hledger-dev:amd64 --deb-native-arch=amd64 --explain --failures deb://$(packages) > out/distcheck.yaml || [ $$? -eq 1 ]
	# test dose2html
	./tools/dose2html.py --srcsdir=out --wwwroot=out/ --packages=$(packages) out/distcheck.yaml out/distcheck.html
	./tools/dose2html.py --srcsdir=out --wwwroot=out/ --packages=$(packages) out/buildcheck.yaml out/buildcheck.html
	./tools/dose2html.py --srcsdir=out --wwwroot=out/ --packages=tmp/packages_armhf_noall_nomaforeign --packages=tests/crossbuild-essential-armhf --packages=tmp/packages out/buildcheck_cross.yaml out/buildcheck_cross.html
	# test networkx dot read/write because there constantly seem to be
	# problems with that:
	#   - endless loop for graphs with attributes in pygraphviz
	#        https://bugs.debian.org/cgi-bin/bugreport.cgi?bug=794444
	#        https://github.com/pygraphviz/pygraphviz/issues/65
	#   - pygraphviz cannot handle graph attributes
	#        https://bugs.debian.org/cgi-bin/bugreport.cgi?bug=819739
	#   - networkx cannot store graph in dot format where a node name contains a colon
	#        https://github.com/networkx/networkx/issues/2050
	#   - python3 support
	#        https://github.com/erocarrera/pydot/issues/76
	#   - dead pydot upstream and too many forks
	#        https://github.com/carlos-jenkins/pydotplus/issues/1
	#   - exclusive use of non-packaged pydotplus fork by networkx
	#        https://bugs.debian.org/cgi-bin/bugreport.cgi?bug=819480
	#   - undeterministic output order
	#        https://github.com/networkx/networkx/issues/1181
	#        https://github.com/networkx/networkx/issues/1267
	#   - unicode encode/decode problems
	#        https://github.com/erocarrera/pydot/issues/24
	#   - networkx API breakages: removal of nx.write_dot and nx.read_dot
	#        http://networkx.readthedocs.io/en/stable/reference/api_1.11.html
	#   - pygraphviz API breakages: AGraph dropped the file parameter
	#        https://github.com/pygraphviz/pygraphviz/commit/21d9153c25ff5d8047c46f48f043f0788ab10da5
	#   - pygraphviz segfauls when reading from a io.StringIO
	#        https://github.com/pygraphviz/pygraphviz/issues/101
	#   - pygraphviz adds the input filename as a graph attribute
	#        https://github.com/pygraphviz/pygraphviz/issues/102
	#   - networkx doesn't parse dot data from memory
	#        https://github.com/networkx/networkx/issues/2249
	dose-ceve --deb-drop-b-d-indep -c "src:acl" --deb-native-arch=amd64 -G pkg -T dot deb://tmp/packages debsrc://tmp/sources > tmp/aclbd.dot
	./tools/graph-shortest-path.py tmp/aclbd.dot --all --source __ID__:"src:acl (= 2.2.52-3)" --target __ID__:"multiarch-support:amd64 (= 2.23-5)" > out/acl-ma-path.dot
	./tools/graph-ancestors.py --target __ID__:"perl:amd64 (= 5.22.2-3)" tmp/aclbd.dot > out/acl_pred.dot
	./tools/graph-descendants.py --source __ID__:"perl:amd64 (= 5.22.2-3)" tmp/aclbd.dot > out/acl_succ.dot
	./tools/graph-neighborhood.py --depth=2 --center __ID__:"perl:amd64 (= 5.22.2-3)" tmp/aclbd.dot > out/acl_neighbors.dot
	# test y-u-no-bootstrap
	# Remove yui-compressor to make src:doxygen bd-uninstallable
	grep-dctrl --not --field Package yui-compressor tmp/packages > tmp/packages_noyui
	./tools/y-u-no-bootstrap.sh --debug --verbose --develop --tmp tmp --output out amd64 tmp/packages_noyui tmp/sources
	# verify results
	$(call diff_tmp_out,misc)

.PHONY: test-default
test-default: $(OCAMLBUILD_BEST)
	rm -rf tmp out
	./tools/native.sh --debug --verbose --develop --output out --tmp tmp --jobs=2 --deb-drop-b-d-indep amd64 tests/sid-amd64-packages-20160830T000000Z tests/sid-sources-20160830T000000Z
	$(call diff_tmp_out,default)

.PHONY: test-selfcontained
test-selfcontained: $(OCAMLBUILD_BEST)
	rm -rf tmp out

=== debian/changelog ===
botch (0.21-8) unstable; urgency=medium

  * add patch accounts for new argparse version in python 3.7 (closes: #912935)

 -- Johannes 'josch' Schauer <josch@debian.org>  Thu, 22 Nov 2018 15:47:58 +0100

botch (0.21-7) unstable; urgency=medium

  * also ignore pycodestyle W504 (closes: #912060)

 -- Johannes 'josch' Schauer <josch@debian.org>  Wed, 21 Nov 2018 08:57:07 +0100

botch (0.21-6) unstable; urgency=medium

  * debian/control: add Build-Depends on dh-python (closes: #896797)
  * Define undefined parameters in shell scripts (closes: #903564)
  * Migrate to networkx 2.0
  * update for graphviz 2.40.1 (closes: #890029)
  * Fix for changed version provides handling of dose3 5.0.1-9
  * tools/graph-difference.py: allow comparison of arbitrary input graphs
  * Rename ma_interpreter.pkggraph to ma_interpreter.xml so that it is checked
    using botch-graph-difference instead of diff
  * debian/control: fix my name
  * bump dh compat level to 11
  * debian/copyright: secure source format uri

 -- Johannes 'josch' Schauer <josch@debian.org>  Sun, 22 Jul 2018 19:07:41 +0200

botch (0.21-5) unstable; urgency=medium

  * add patch fixing test output for changed dictionary ordering from Python
    3.5 to 3.6. Also bump build dependency on Python (closes: #869586)
  * remove empty recommends and suggests fields from botch-doc
  * use https URI in debian/watch
  * bump Standards-Version to 4.1.1 (no changes)

 -- Johannes Schauer <josch@debian.org>  Wed, 01 Nov 2017 11:13:50 +0100

botch (0.21-4) unstable; urgency=medium

  * Add patch to fix FTBFS due to new pycodestyle and error E722 (closes:
    #867005)
  * Replace jquery-tablesorter/themes/blue/style.css with
    jquery-tablesorter/css/theme.blue.css after upstream switch (closes:
    #867607)
  * Build-Depends on ocamlbuild to ease a future transition to ocaml 4.05.0
    (closes: #869852)
  * bump Standards-Version to 4.0.0 (no changes required)
  * make botch-doc Multi-Arch:foreign

 -- Johannes Schauer <josch@debian.org>  Wed, 02 Aug 2017 13:13:10 +0200

botch (0.21-3) unstable; urgency=medium

  * Add patch to fix FTBFS due to API breakage introduced by src:dose3 5.0.1-8
    (closes: #852917)

 -- Johannes Schauer <josch@debian.org>  Sat, 28 Jan 2017 23:32:39 +0100

botch (0.21-2) unstable; urgency=medium

  * python3-pygraphviz dropped the file attribute. Thus adapting the code
    accordingly and bumping dependency to 1.4~rc1
  * bump Standards-Version to 3.9.8 (no changes required)
  * Do not build depend on -1-revisions to ease backports
  * Remove unused lintian overrides

 -- Johannes Schauer <josch@debian.org>  Mon, 09 Jan 2017 13:16:33 +0100

botch (0.21-1) unstable; urgency=medium

  * new upstream release
     - changes testcases for gringo 5.1.0 (closes: #847831)
  * remove all patches
  * fail if diff in autopkgtest returns nonzero exit (closes: #847832)
  * move diff_tmp_out of autopkgtest into its own script

 -- Johannes Schauer <josch@debian.org>  Tue, 20 Dec 2016 19:45:42 +0100

botch (0.20-3) unstable; urgency=medium

  * Add two patches from upstream which switch from pep8 to pycodestyle
    (closes: #844964)

 -- Johannes Schauer <josch@debian.org>  Sat, 19 Nov 2016 20:55:30 +0100

botch (0.20-2) unstable; urgency=medium

  * Apply patch from upstream catering for missing 'depends' field in dose3
    yaml output

 -- Johannes Schauer <josch@debian.org>  Tue, 01 Nov 2016 08:05:41 +0100

botch (0.20-1) unstable; urgency=medium

  * new upstream release

 -- Johannes Schauer <josch@debian.org>  Mon, 31 Oct 2016 12:28:52 +0100

botch (0.19-3) unstable; urgency=medium

  * Update autopkgtest test suite to 0.19 release

 -- Johannes Schauer <josch@debian.org>  Tue, 25 Oct 2016 22:34:25 +0200

botch (0.19-2) unstable; urgency=medium

  * Run ocamlbuild with -lflags -runtime-variant,_pic to work around Debian
    bug #837359

 -- Johannes Schauer <josch@debian.org>  Thu, 20 Oct 2016 07:17:42 +0200

botch (0.19-1) unstable; urgency=medium

  * new upstream release
  * drop patches as they were integrated upstream
  * add a Suggests:botch-doc to botch (closes: #839924)
  * make the botch package description less verbose (closes: #839926)
  * fix VCS-Git field to point to the botch git (closes: #839901)
  * add a README.Debian
  * update lintian overrides (remove hardening-no-relro and add
    hardening-no-bindnow and hardening-no-pie)

 -- Johannes Schauer <josch@debian.org>  Wed, 19 Oct 2016 23:22:38 +0200

botch (0.18-5) unstable; urgency=medium

  * dummy upload to test source-only uploads without an empty Binary field in
    the .changes file

 -- Johannes Schauer <josch@debian.org>  Thu, 22 Sep 2016 12:44:15 +0200

botch (0.18-4) unstable; urgency=medium

  * backport patch to output progress for botch-clean-repository via
    0001-clean-repository.ml-add-progress-option.patch

 -- Johannes Schauer <josch@debian.org>  Thu, 22 Sep 2016 12:37:57 +0200

botch (0.18-3) unstable; urgency=medium

  * backport patch which applies _tag rules to *.byte instead of just applying
    them to *.d.byte via
    0002-_tags-don-t-apply-rule-to-.d.byte-only-but-to-.byte.patch
  * build-depend on libatdgen-ocaml-dev (>= 1.9.1-2) to make sure to depend on
    a version of atdgen with bug #837804 fixed (provides /usr/bin/atdgen on
    all architectures)

 -- Johannes Schauer <josch@debian.org>  Fri, 16 Sep 2016 09:58:08 +0200

botch (0.18-2) unstable; urgency=medium

  * backport patch that retries parmap with smaller chunk sizes to cater for
    32 bit architectures with very limited memory constraints
    0001-buildGraph.ml-retry-with-smaller-chunk-sizes-if-parm.patch

 -- Johannes Schauer <josch@debian.org>  Fri, 16 Sep 2016 07:06:02 +0200

botch (0.18-1) unstable; urgency=medium

  * new upstream release
      - restores compatibility with dose3 (closes: #827977)
  * add dependency on dpkg-dev (closes: #832028)
  * remove all patches
  * replace build-depends on pyflakes by pyflakes3


=== debian/control ===
Source: botch
Section: utils
Priority: optional
Maintainer: Johannes 'josch' Schauer <josch@debian.org>
Homepage: https://gitlab.mister-muffin.de/debian-bootstrap/botch/wikis/home
Standards-Version: 4.1.1
# these are needed to run debian/rules clean
Build-Depends:
 debhelper (>= 11),
 dh-ocaml,
 dh-python,
 ocaml-nox,
 ocamlbuild,
 python3 (>= 3.6),
Build-Depends-Arch:
 cppo,
 ocaml-findlib,
 libextlib-ocaml-dev,
 libocamlgraph-ocaml-dev,
 libatdgen-ocaml-dev (>= 1.9.1-2),
 libxmlm-ocaml-dev,
 libparmap-ocaml-dev,
 libdose3-ocaml-dev (>= 5.0.1),
 dose-builddebcheck (>= 5.0.1-10) <!nocheck>,
 dose-extra (>= 5.0.1)           <!nocheck>,
 dctrl-tools                     <!nocheck>,
 aspcud                          <!nocheck>,
 python3-apt                     <!nocheck>,
 python3-debian                  <!nocheck>,
 python3-networkx (>= 2.1)       <!nocheck>,
 python3-yaml                    <!nocheck>,
 pycodestyle                     <!nocheck>,
 pyflakes3                       <!nocheck>,
 python3-pygraphviz (>= 1.4~rc1) <!nocheck>,
 gsfonts                         <!nocheck>,
 libgraph-easy-perl              <!nocheck>,
 graphviz                        <!nocheck>,
 libcdt5 (>= 2.40.1)             <!nocheck>,
 libcdt5 (<< 2.40.1.0~)          <!nocheck>,
Build-Depends-Indep:
 markdown <!nodoc>,
 graphviz <!nodoc>,
Vcs-Browser: https://browse.dgit.debian.org/botch.git/
Vcs-Git: https://git.dgit.debian.org/botch

Package: botch
Architecture: any
Depends:
 ${ocaml:Depends},
 ${misc:Depends},
 ${shlibs:Depends},
 ${python3:Depends},
 dose-builddebcheck (>= 5.0.1-1),
 dose-extra (>= 5.0.1-1),
 dctrl-tools,
 aspcud,
 python3-apt,
 python3-debian,
 python3-networkx (>= 2.1-1),
 python3-yaml,
 python3-pygraphviz (>= 1.4~rc1),
 zutils,
 dpkg-dev,
 libyojson-ocaml-dev,
# libjs-jquery-tablesorter and libjs-jquery are needed to look at the generated
# HTML with javascript bling
Recommends:
 libjs-jquery-tablesorter,
 libjs-jquery
# devscripts and libsoap-lite-perl are needed for /usr/bin/bts which is in turn
# needed by botch-dose2html because there is no soap module for python3
# libgraph-easy-perl is only needed for its /usr/bin/graph-easy program which
# is used in y-u-no-bootstrap and y-u-b-d-transitive-essential (but optional)
Suggests:
 libgraph-easy-perl,
 devscripts,
 www-browser,
 libsoap-lite-perl,
 botch-doc,
Description: tools to create and analyse dependency graphs
 botch is a collection of tools to create and analyze dependency graphs. This
 task is facilitated by a range of individual tools which use the deb822 and
 graphml formats to exchange information with each other.
 .
 The tools installed by this package provide these features:
 .
  - analyze graphs
  - transform Packages and Sources control files
  - create graphs of different types
  - analysis of Packages and Sources control files
  - handling of botch-internal formats
  - dose3 wrappers
  - set operations on Packages or Sources files
  - create build orders
  - conversion of graphs
  - shell scripts connecting the tools for meaningful operations
  - extract regions from graphs

Package: botch-doc
Section: doc
Architecture: all
Depends: ${misc:Depends}
Multi-Arch: foreign
Description: Bootstrapping helper - documentation
 Botch stands for bootstrap/build ordering tool chain and allows one to create
 and analyze bootstrapping dependency graphs, creates suggestions how to break
 dependency cycles and generates a build order.
 .
 This package contains the documentation.

## botch 0.22

=== Makefile ===
--- 
+++ 
@@ -1,4 +1,4 @@
-VERSION=0.21
+VERSION=0.22
 
 BIN_OPT:= \
   create-graph.native \
@@ -146,7 +146,7 @@
 		for f in tests/$(1)/$$t/* $$t/*; do basename "$$f"; done | sort | uniq | while read f; do \
 			echo checking $$f; \
 			case "$$f" in \
-				*.xml) \
+				*.xml|*.dot) \
 					echo "+ ./tools/graph-difference.py \"tests/$(1)/$$t/$$f\" \"$$t/$$f\""; \
 					while : ; do ./tools/graph-difference.py "tests/$(1)/$$t/$$f" "$$t/$$f"; exit=$$?; if [ $$exit -eq 139 ]; then echo segfault; continue; fi; if [ $$exit -ne 0 ]; then exit 1; else break; fi; done;; \
 				*) \
@@ -180,10 +180,12 @@
 	./buildgraph2srcgraph.$(OCAMLBUILD_BEST) tmp/closurebuildgraph.xml --deb-drop-b-d-indep --deb-native-arch=amd64 tmp/packages tmp/sources > tmp/closuresrcgraph.xml
 	./tools/calcportsmetric.py tmp/strongsrcgraph.xml tmp/closuresrcgraph.xml > out/importance_metric.txt
 	# test botch-multiarch-interpreter-problem
-	dose-ceve --deb-drop-b-d-indep --deb-native-arch=amd64 -G pkg -T grml deb://tmp/packages debsrc://tmp/sources > tmp/ma_interpreter.pkggraph
-	./tools/multiarch-interpreter-problem.py --packages tmp/packages tmp/ma_interpreter.pkggraph > out/ma_interpreter.txt
+	dose-ceve --deb-drop-b-d-indep --deb-native-arch=amd64 -G pkg -T grml deb://tmp/packages debsrc://tmp/sources > tmp/ma_interpreter.xml
+	./tools/multiarch-interpreter-problem.py --packages tmp/packages tmp/ma_interpreter.xml > out/ma_interpreter.txt
 	# test y-u-b-d-transitive-essential
 	./tools/y-u-b-d-transitive-essential.sh --debug --verbose --develop --tmp tmp --output out amd64 tmp/packages tmp/sources acl
+	# remove svg because graphviz changes its output format slightly every other version
+	rm out/acl_2.2.52-3_n20.svg
 	# test botch-buildcheck-more-problems
 	./buildcheck-more-problems.$(OCAMLBUILD_BEST) --verbose --progress --checkonly=plasma-desktop,haskell-hledger-ui --deb-native-arch=amd64 --explain --failures $(packages) $(sources) > out/buildcheck.yaml || [ $$? -eq 1 ]
 	# test botch-buildcheck-more-problems cross because we want to be able
@@ -237,6 +239,8 @@
 	# Remove yui-compressor to make src:doxygen bd-uninstallable
 	grep-dctrl --not --field Package yui-compressor tmp/packages > tmp/packages_noyui
 	./tools/y-u-no-bootstrap.sh --debug --verbose --develop --tmp tmp --output out amd64 tmp/packages_noyui tmp/sources
+	# remove svg because graphviz changes its output format slightly every other version
+	rm out/doxygen_1.8.11-3.svg
 	# verify results
 	$(call diff_tmp_out,misc)
 
@@ -247,5 +251,3 @@
 	$(call diff_tmp_out,default)
 
 .PHONY: test-selfcontained
-test-selfcontained: $(OCAMLBUILD_BEST)
-	rm -rf tmp out

=== debian/changelog ===
botch (0.22-4ubuntu1) groovy; urgency=medium

  * Override dh_dwz due to failure for new binutils (RC bug pending)

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Mon, 20 Jul 2020 21:45:43 +0200

botch (0.22-4) unstable; urgency=medium

  * add patch to fix pyflakes failure (closes: #963399)
  * add patch to fix pycodestyle error E741

 -- Johannes 'josch' Schauer <josch@debian.org>  Mon, 22 Jun 2020 11:40:47 +0200

botch (0.22-3) unstable; urgency=medium

  * add debian/salsa-ci.yml
  * change vcs to salsa because of #914260
  * debian/upstream/signing-key.asc: drop extra signatures
  * debian/control: bump standards-version to 4.5.0
  * debian/tests/misc: remove out/acl_2.2.52-3_n20.svg and
    out/doxygen_1.8.11-3.svg because graphviz stores its version in it

 -- Johannes 'josch' Schauer <josch@debian.org>  Sun, 23 Feb 2020 08:38:11 +0100

botch (0.22-2) unstable; urgency=medium

  * Add patch as workaround for bug #946980. On 32bit architectures, botch
    will now not attempt using parmap for parallelization (closes: #946817)
  * Fixup last changelog entry that forgot a closes: #944473

 -- Johannes 'josch' Schauer <josch@debian.org>  Thu, 02 Jan 2020 15:02:44 +0100

botch (0.22-1) unstable; urgency=medium

  * New upstream release
  * drop debian/patches -> all have been applied upstream
  * drop B-D on libcdt5 because tests are not testing graphviz version anymore
    (closes: #944473)
  * replace deprecated $ADTTMP with $AUTOPKGTEST_TMP
  * bump Standards-Version to 4.4.1 (no changes)
  * add Rules-Requires-Root: no
  * bump debhelper version to 12
  * use debhelper-compat B-D instead of debian/compat
  * add B-D: black <!nocheck>

 -- Johannes 'josch' Schauer <josch@debian.org>  Sun, 15 Dec 2019 05:28:44 +0100

=== debian/rules ===
#!/usr/bin/make -f

# include for OCAMLBUILD_BEST
include /usr/share/ocaml/ocamlvars.mk

%:
	dh $@ --with python3,ocaml

# only build the wiki in the indep target if no nodoc
override_dh_auto_build-indep:
ifeq ($(filter nodoc,$(DEB_BUILD_OPTIONS))$(filter nodoc,$(DEB_BUILD_PROFILES)),)
	$(MAKE) wiki
endif

# build everything else in the arch target
override_dh_auto_build-arch:
	$(MAKE) $(OCAMLBUILD_BEST) man

# don't run tests in the indep target
override_dh_auto_test-indep:

# only run tests in the arch target if no nocheck
override_dh_auto_test-arch:
ifeq ($(filter nocheck,$(DEB_BUILD_OPTIONS))$(filter nocheck,$(DEB_BUILD_PROFILES)),)
	$(MAKE) test
endif

override_dh_dwz:

# only install the wiki in the indep target if no nodoc
override_dh_auto_install-indep:
ifeq ($(filter nodoc,$(DEB_BUILD_OPTIONS))$(filter nodoc,$(DEB_BUILD_PROFILES)),)
	$(MAKE) DESTDIR="$(CURDIR)/debian/tmp" install-wiki
else
	# at least create the target directory so that dh_install doesn't barf later
	mkdir -p "$(CURDIR)/debian/tmp/usr/share/doc/botch"
endif

# install everything else in the arch target
override_dh_auto_install-arch:
	$(MAKE) DESTDIR="$(CURDIR)/debian/tmp" install-bin install-man

## botch 0.23

=== Makefile ===
--- 
+++ 
@@ -1,4 +1,4 @@
-VERSION=0.22
+VERSION=0.23
 
 BIN_OPT:= \
   create-graph.native \

=== debian/changelog ===
botch (0.23-1) unstable; urgency=medium

  * New upstream release
  * drop patches and add patch replacing parany with parmap
  * add patch to fix expected html in tests

 -- Johannes 'josch' Schauer <josch@debian.org>  Fri, 05 Feb 2021 01:51:43 +0100

botch (0.22-5) unstable; urgency=medium

  * patch tools/stat-html.py to make black happy (closes: #972258)
  * add debian/patches/testsuite-fixes-new-ocaml.patch because of changes in
    dose3 and ocaml since the last upload

 -- Johannes 'josch' Schauer <josch@debian.org>  Sat, 17 Oct 2020 16:53:50 +0200

=== debian/control ===
--- 
+++ 
@@ -3,10 +3,11 @@
 Priority: optional
 Maintainer: Johannes 'josch' Schauer <josch@debian.org>
 Homepage: https://gitlab.mister-muffin.de/debian-bootstrap/botch/wikis/home
-Standards-Version: 4.1.1
+Standards-Version: 4.5.0
+Rules-Requires-Root: no
 # these are needed to run debian/rules clean
 Build-Depends:
- debhelper (>= 11),
+ debhelper-compat (= 12),
  dh-ocaml,
  dh-python,
  ocaml-nox,
@@ -35,13 +36,12 @@
  gsfonts                         <!nocheck>,
  libgraph-easy-perl              <!nocheck>,
  graphviz                        <!nocheck>,
- libcdt5 (>= 2.40.1)             <!nocheck>,
- libcdt5 (<< 2.40.1.0~)          <!nocheck>,
+ black                           <!nocheck>,
 Build-Depends-Indep:
  markdown <!nodoc>,
  graphviz <!nodoc>,
-Vcs-Browser: https://browse.dgit.debian.org/botch.git/
-Vcs-Git: https://git.dgit.debian.org/botch
+Vcs-Browser: https://salsa.debian.org/debian/botch
+Vcs-Git: https://salsa.debian.org/debian/botch.git
 
 Package: botch
 Architecture: any

## botch 0.24

=== Makefile ===
--- 
+++ 
@@ -1,4 +1,4 @@
-VERSION=0.23
+VERSION=0.24
 
 BIN_OPT:= \
   create-graph.native \
@@ -247,7 +247,7 @@
 .PHONY: test-default
 test-default: $(OCAMLBUILD_BEST)
 	rm -rf tmp out
-	./tools/native.sh --debug --verbose --develop --output out --tmp tmp --jobs=2 --deb-drop-b-d-indep amd64 tests/sid-amd64-packages-20160830T000000Z tests/sid-sources-20160830T000000Z
+	./tools/native.sh --debug --verbose --develop --output out --tmp tmp --deb-drop-b-d-indep amd64 tests/sid-amd64-packages-20160830T000000Z tests/sid-sources-20160830T000000Z
 	$(call diff_tmp_out,default)
 
 .PHONY: test-selfcontained

=== doc/wiki/Makefile ===
md=$(wildcard *.markdown)
html=$(patsubst %.markdown,%.html,$(md))
dot=$(wildcard *.dot)
png=$(patsubst %.dot,%.png,$(dot))
docdir=/usr/share/doc/botch

.PHONY: all
all: $(html) $(png)

%.html: %.markdown
	sed -e 's/\[\([^]]\+\)\](\([^\/)]\+\))/<a href="\2.html">\1<\/a>/' -e 's#https://gitlab.mister-muffin.de/uploads/debian-bootstrap/botch/.\{10\}/\([^)]\+\)#\1#' $< | markdown > $@

%.png: %.dot
	dot -T png $< > $@

.PHONY: install
install: all
	mkdir -p $(DESTDIR)$(docdir)/wiki
	cp $(html) $(png) $(DESTDIR)$(docdir)/wiki

.PHONY: clean
clean:
	rm -f $(html) $(png)

=== debian/changelog ===
botch (0.24-6build2) resolute; urgency=medium

  * Rebuild against new OCAML ABIs.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Tue, 21 Oct 2025 20:48:25 +0200

botch (0.24-6build1) questing; urgency=medium

  * Rebuild against new OCAML ABIs.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Wed, 18 Jun 2025 09:42:58 +0200

botch (0.24-6) unstable; urgency=medium

  * debian/salsa-ci.yml: modernize
  * debian/patches:
     - new version of ocaml-atd
     - refresh parsing of argparse --help output in python 3.13 (closes:
       #1092479)

 -- Johannes Schauer Marin Rodrigues <josch@debian.org>  Thu, 13 Feb 2025 23:30:00 +0100

botch (0.24-5) unstable; urgency=medium

  [ Stéphane Glondu ]
  * Use Stdlib instead of Pervasives  (Closes: #1078356)

  [ Johannes Schauer Marin Rodrigues ]
  * debian/control: add Recommends on wget (Closes: #928682)
  * debian/control: fix Hompage to point to salsa (Closes: #988411)

 -- Johannes Schauer Marin Rodrigues <josch@debian.org>  Sun, 11 Aug 2024 11:22:45 +0200

botch (0.24-4) unstable; urgency=medium

  * Team upload (ack by maintainer)
  * Depend on yojson-tools instead of old libyojson-ocaml-dev
    to fix missing ydump tool (split from libyojson-ocaml-dev)
    This fixes autopkgtests and build-failure
    (Closes: #1073199, #1073259)

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Fri, 14 Jun 2024 14:01:21 +0200

botch (0.24-3) unstable; urgency=medium

  * debian/control: switch out unmaintained markdown for discount

 -- Johannes Schauer Marin Rodrigues <josch@debian.org>  Mon, 10 Jun 2024 12:40:37 +0200

botch (0.24-2) unstable; urgency=medium

  * add patch to make tests work with black 23.1.0 (closes: #1031469)

 -- Johannes Schauer Marin Rodrigues <josch@debian.org>  Fri, 17 Feb 2023 15:49:11 +0100

botch (0.24-1) unstable; urgency=medium

  * New upstream release
     - port to dose3 7.0.0 (closes: #1006049)
  * debian/watch: bump version to 4
  * debian/control: bump dh version to 13
  * debian/control: bump Standards-Version to 4.5.1
  * debian/botch.install: list manpages
  * fix my name
  * drop patches
  * remove parmap and parany
  * add patch fixing Bi_outbuf -> Buffer
  * patch json test formatting
  * debian/tests: remove --jobs
  * debian/source/lintian-overrides: override some lintian false-positives
  * debian/salsa-ci.yml: disable crossbuilding

 -- Johannes Schauer Marin Rodrigues <josch@debian.org>  Mon, 31 Oct 2022 12:51:07 +0100

=== debian/control ===
--- 
+++ 
@@ -1,13 +1,13 @@
 Source: botch
 Section: utils
 Priority: optional
-Maintainer: Johannes 'josch' Schauer <josch@debian.org>
-Homepage: https://gitlab.mister-muffin.de/debian-bootstrap/botch/wikis/home
-Standards-Version: 4.5.0
+Maintainer: Johannes Schauer Marin Rodrigues <josch@debian.org>
+Homepage: https://salsa.debian.org/debian-bootstrap-team/botch/-/wikis/home
+Standards-Version: 4.5.1
 Rules-Requires-Root: no
 # these are needed to run debian/rules clean
 Build-Depends:
- debhelper-compat (= 12),
+ debhelper-compat (= 13),
  dh-ocaml,
  dh-python,
  ocaml-nox,
@@ -20,7 +20,6 @@
  libocamlgraph-ocaml-dev,
  libatdgen-ocaml-dev (>= 1.9.1-2),
  libxmlm-ocaml-dev,
- libparmap-ocaml-dev,
  libdose3-ocaml-dev (>= 5.0.1),
  dose-builddebcheck (>= 5.0.1-10) <!nocheck>,
  dose-extra (>= 5.0.1)           <!nocheck>,
@@ -37,8 +36,9 @@
  libgraph-easy-perl              <!nocheck>,
  graphviz                        <!nocheck>,
  black                           <!nocheck>,
+ yojson-tools                    <!nocheck>,
 Build-Depends-Indep:
- markdown <!nodoc>,
+ discount <!nodoc>,
  graphviz <!nodoc>,
 Vcs-Browser: https://salsa.debian.org/debian/botch
 Vcs-Git: https://salsa.debian.org/debian/botch.git
@@ -61,10 +61,11 @@
  python3-pygraphviz (>= 1.4~rc1),
  zutils,
  dpkg-dev,
- libyojson-ocaml-dev,
+ yojson-tools,
 # libjs-jquery-tablesorter and libjs-jquery are needed to look at the generated
 # HTML with javascript bling
 Recommends:
+ wget,
  libjs-jquery-tablesorter,
  libjs-jquery
 # devscripts and libsoap-lite-perl are needed for /usr/bin/bts which is in turn

=== debian/tests/control ===
Tests: default selfcontained cross misc
Restrictions: allow-stderr
# libgraph-easy-perl is only a Suggests because it's entirely optional. Thus
# listing it here.
# gsfonts is not required either but graphviz will require the font
# "Nimbus Roman No9 L" to exactly replicate the right dot rendering.
Depends: @, libgraph-easy-perl, gsfonts

=== debian/watch ===
version=4
opts=pgpsigurlmangle=s/$/.asc/ \
https://mister-muffin.de/botch/ \./botch-([\d\.]+)\.tar\.xz
